/* Fo
 * fo-doc-gp.h: Wrapper for libfo output document
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-doc-gp.h,v 1.3 2003/05/23 16:53:29 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_DOC_GP_H__
#define __FO_DOC_GP_H__

#include <libfo/fo-utils.h>
#include <datatype/fo-datatype.h>
#include <libfo/fo-doc.h>

G_BEGIN_DECLS

typedef struct _FoDocGP      FoDocGP;
typedef struct _FoDocGPClass FoDocGPClass;

#define FO_TYPE_DOC_GP            (fo_doc_gp_get_type ())
#define FO_DOC_GP(object)         (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_DOC_GP, FoDocGP))
#define FO_DOC_GP_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_DOC_GP, FoDocGPClass))
#define FO_IS_DOC_GP(object)      (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_DOC_GP))
#define FO_IS_DOC_GP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_DOC_GP))
#define FO_DOC_GP_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_DOC_GP, FoDocGPClass))


GType   fo_doc_gp_get_type (void);
FoDoc * fo_doc_gp_new (void);

void    fo_doc_gp_set_parameter (FoDoc *fo_doc,
			      const gchar *key,
			      const gchar *value);
void    fo_doc_gp_set_value     (FoDoc       *fo_doc,
			      const gchar *key,
			      gfloat       value);
void    fo_doc_gp_set_info      (FoDoc       *fo_doc,
			      const gchar *key,
			      const gchar *value);
FoDoc * fo_doc_gp_ref    (FoDoc  *fo_doc);
void    fo_doc_gp_unref  (FoDoc  *fo_doc);

void    fo_doc_gp_open_file (FoDoc       *fo_doc,
			     const gchar *filename,
			     GError     **error);

G_END_DECLS

#endif /* !__FO_DOC_GP_H__ */
