/* Fo
 * fo-property-background-color.h: 'background-color' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-background-color.h,v 1.4 2003/04/15 12:01:35 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_BACKGROUND_COLOR_H__
#define __FO_PROPERTY_BACKGROUND_COLOR_H__

#include <pango/pango-attributes.h>
#include <libfo/fo-utils.h>
#include <property/fo-property.h>

G_BEGIN_DECLS

/* background-color */
/* <color> | transparent | inherit */
/* Initial value: transparent */
typedef enum {
  FO_ENUM_BACKGROUND_COLOR_TRANSPARENT
} FoEnumBackgroundColor;

GType fo_enum_background_color_get_type (void);
#define FO_TYPE_ENUM_BACKGROUND_COLOR fo_enum_background_color_get_type ()

#define FO_TYPE_PROPERTY_BACKGROUND_COLOR              (fo_property_background_color_get_type ())
#define FO_PROPERTY_BACKGROUND_COLOR(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_BACKGROUND_COLOR, FoPropertyBackgroundColor))
#define FO_PROPERTY_BACKGROUND_COLOR_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_BACKGROUND_COLOR, FoPropertyBackgroundColorClass))
#define FO_IS_PROPERTY_BACKGROUND_COLOR(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_BACKGROUND_COLOR))
#define FO_IS_PROPERTY_BACKGROUND_COLOR_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_BACKGROUND_COLOR))
#define FO_PROPERTY_BACKGROUND_COLOR_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_BACKGROUND_COLOR, FoPropertyBackgroundColorClass))


typedef struct _FoPropertyBackgroundColor      FoPropertyBackgroundColor;
typedef struct _FoPropertyBackgroundColorClass FoPropertyBackgroundColorClass;

GType       fo_property_background_color_get_type    (void) G_GNUC_CONST;
FoProperty* fo_property_background_color_new         (void);
FoDatatype* fo_property_background_color_new_from_expression (const gchar *expression,
							      FoContext   *context,
							      FoProperty    *current_font_size,
							      FoFo *fo_node,
							      GError    **error);
FoDatatype* fo_property_background_color_get_initial (void);
PangoAttribute* fo_property_background_color_new_attr (FoDatatype *datatype);
G_END_DECLS

#endif /* !__FO_PROPERTY_BACKGROUND_COLOR_H__ */
