/* Fo
 * fo-property-font-family.h: 'font-family' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-font-family.h,v 1.3 2003/03/21 14:41:30 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_FONT_FAMILY_H__
#define __FO_PROPERTY_FONT_FAMILY_H__

#include <libfo/fo-utils.h>
#include "fo-property.h"

G_BEGIN_DECLS

/* font-family */
/* [[ <family-name> | <generic-family> ],]* [<family-name> | <generic-family>] | inherit */
/* Initial value: depends on user agent */
typedef enum {
  FO_ENUM_FONT_FAMILY_SERIF,
  FO_ENUM_FONT_FAMILY_SANS_SERIF,
  FO_ENUM_FONT_FAMILY_CURSIVE,
  FO_ENUM_FONT_FAMILY_FANTASY,
  FO_ENUM_FONT_FAMILY_MONOSPACE
} FoEnumFontFamily;

GType fo_enum_font_family_get_type (void);
#define FO_TYPE_ENUM_FONT_FAMILY fo_enum_font_family_get_type ()

#define FO_TYPE_PROPERTY_FONT_FAMILY              (fo_property_font_family_get_type ())
#define FO_PROPERTY_FONT_FAMILY(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_FONT_FAMILY, FoPropertyFontFamily))
#define FO_PROPERTY_FONT_FAMILY_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_FONT_FAMILY, FoPropertyFontFamilyClass))
#define FO_IS_PROPERTY_FONT_FAMILY(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_FONT_FAMILY))
#define FO_IS_PROPERTY_FONT_FAMILY_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_FONT_FAMILY))
#define FO_PROPERTY_FONT_FAMILY_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_FONT_FAMILY, FoPropertyFontFamilyClass))


typedef struct _FoPropertyFontFamily      FoPropertyFontFamily;
typedef struct _FoPropertyFontFamilyClass FoPropertyFontFamilyClass;

GType       fo_property_font_family_get_type    (void) G_GNUC_CONST;
FoProperty* fo_property_font_family_new         (void);
FoProperty* fo_property_font_family_get_initial (void);

FoProperty* fo_property_font_family_new_from_expression (const gchar *expression,
							 FoContext   *context,
							 FoProperty    *current_font_size,
							 FoFo *fo_node,
							 GError    **error);
G_END_DECLS

#endif /* !__FO_PROPERTY_FONT_FAMILY_H__ */
