/* Fo
 * fo-property-keep-together.h: 'keep-together' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-keep-together.h,v 1.2 2003/03/21 14:41:34 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_KEEP_TOGETHER_H__
#define __FO_PROPERTY_KEEP_TOGETHER_H__

#include <libfo/fo-utils.h>
#include "fo-context.h"

G_BEGIN_DECLS

#define FO_TYPE_PROPERTY_KEEP_TOGETHER              (fo_property_keep_together_get_type ())
#define FO_PROPERTY_KEEP_TOGETHER(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_KEEP_TOGETHER, FoPropertyKeepTogether))
#define FO_PROPERTY_KEEP_TOGETHER_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_KEEP_TOGETHER, FoPropertyKeepTogetherClass))
#define FO_IS_PROPERTY_KEEP_TOGETHER(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_KEEP_TOGETHER))
#define FO_IS_PROPERTY_KEEP_TOGETHER_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_KEEP_TOGETHER))
#define FO_PROPERTY_KEEP_TOGETHER_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_KEEP_TOGETHER, FoPropertyKeepTogetherClass))


typedef struct _FoPropertyKeepTogether      FoPropertyKeepTogether;
typedef struct _FoPropertyKeepTogetherClass FoPropertyKeepTogetherClass;

GType       fo_property_keep_together_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_keep_together_new           (void);

void fo_property_keep_together_set_value (FoProperty *property,
                                          FoDatatype *new_value);
FoDatatype* fo_property_keep_together_get_value (FoProperty *property);
FoProperty* fo_property_keep_together_new_from_expression (const gchar *expression,
                                                           FoContext   *context,
                                                           FoProperty  *current_font_size,
                                                           FoFo        *fo_node,
                                                           GError     **error);
FoProperty* fo_property_keep_together_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_KEEP_TOGETHER_H__ */
