/* Fo
 * fo-property-margin-top.h: margin-top property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-margin-top.h,v 1.2 2003/03/21 14:41:38 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */
#ifndef __FO_PROPERTY_MARGIN_TOP_H__
#define __FO_PROPERTY_MARGIN_TOP_H__

#include <libfo/fo-utils.h>

G_BEGIN_DECLS

/* margin-top */
/* <margin-width> | inherit */
typedef enum {
  FO_ENUM_MARGIN_TOP_AUTO,
  FO_ENUM_MARGIN_TOP_INHERIT
} FoEnumMarginTop;

GType fo_enum_margin_top_get_type (void);
#define FO_TYPE_ENUM_MARGIN_TOP fo_enum_margin_top_get_type ()

#define FO_TYPE_PROPERTY_MARGIN_TOP              (fo_property_margin_top_get_type ())
#define FO_PROPERTY_MARGIN_TOP(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_MARGIN_TOP, FoPropertyMarginTop))
#define FO_PROPERTY_MARGIN_TOP_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_MARGIN_TOP, FoPropertyMarginTopClass))
#define FO_IS_PROPERTY_MARGIN_TOP(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_MARGIN_TOP))
#define FO_IS_PROPERTY_MARGIN_TOP_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_MARGIN_TOP))
#define FO_PROPERTY_MARGIN_TOP_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_MARGIN_TOP, FoPropertyMarginTopClass))


typedef struct _FoPropertyMarginTop      FoPropertyMarginTop;
typedef struct _FoPropertyMarginTopClass FoPropertyMarginTopClass;

GType       fo_property_margin_top_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_margin_top_new           (void);

void fo_property_margin_top_set_value (FoProperty *property,
		      FoDatatype *new_value);
FoDatatype* fo_property_margin_top_get_value (FoProperty *property);
FoProperty* fo_property_margin_top_new_from_expression (const gchar *expression,
						    FoContext   *context,
						    FoProperty    *current_font_size,
							 FoFo *fo_node,
                                            GError    **error);
FoProperty* fo_property_margin_top_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_MARGIN_TOP_H__ */
