/* Fo
 * fo-property-padding.h: Common padding property definitions
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-padding.h,v 1.2 2003/03/21 14:41:39 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_PADDING_H__
#define __FO_PROPERTY_PADDING_H__

#include <libfo/fo-utils.h>
#include <fo-property.h>

typedef struct _FoPropertyPadding      FoPropertyPadding;
typedef struct _FoPropertyPaddingClass FoPropertyPaddingClass;

G_BEGIN_DECLS

#define FO_TYPE_PROPERTY_PADDING              (fo_property_padding_get_type ())
#define FO_PROPERTY_PADDING(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_PADDING, FoPropertyPadding))
#define FO_PROPERTY_PADDING_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_PADDING, FoPropertyPaddingClass))
#define FO_IS_PROPERTY_PADDING(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_PADDING))
#define FO_IS_PROPERTY_PADDING_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_PADDING))
#define FO_PROPERTY_PADDING_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_PADDING, FoPropertyPaddingClass))

GType       fo_property_padding_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_padding_new           (void);
void        fo_property_padding_resolve (FoContext *current_context,
					FoContext *parent_context);
FoDatatype* fo_property_padding_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_PADDING_H__ */
