/* Fo
 * fo-property-page-height.h: page-height property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-page-height.h,v 1.2 2003/03/21 14:41:39 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */
#ifndef __FO_PROPERTY_PAGE_HEIGHT_H__
#define __FO_PROPERTY_PAGE_HEIGHT_H__

#include <libfo/fo-utils.h>

G_BEGIN_DECLS

/* page-height */
/* auto | indefinite | <length> | inherit */
typedef enum {
  FO_ENUM_PAGE_HEIGHT_AUTO,
  FO_ENUM_PAGE_HEIGHT_INDEFINITE,
  FO_ENUM_PAGE_HEIGHT_INHERIT
} FoEnumPageHeight;

GType fo_enum_page_height_get_type (void);
#define FO_TYPE_ENUM_PAGE_HEIGHT fo_enum_page_height_get_type ()

#define FO_TYPE_PROPERTY_PAGE_HEIGHT              (fo_property_page_height_get_type ())
#define FO_PROPERTY_PAGE_HEIGHT(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_PAGE_HEIGHT, FoPropertyPageHeight))
#define FO_PROPERTY_PAGE_HEIGHT_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_PAGE_HEIGHT, FoPropertyPageHeightClass))
#define FO_IS_PROPERTY_PAGE_HEIGHT(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_PAGE_HEIGHT))
#define FO_IS_PROPERTY_PAGE_HEIGHT_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_PAGE_HEIGHT))
#define FO_PROPERTY_PAGE_HEIGHT_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_PAGE_HEIGHT, FoPropertyPageHeightClass))


typedef struct _FoPropertyPageHeight      FoPropertyPageHeight;
typedef struct _FoPropertyPageHeightClass FoPropertyPageHeightClass;

GType       fo_property_page_height_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_page_height_new           (void);

void fo_property_page_height_set_value (FoProperty *property,
		      FoDatatype *new_value);
FoDatatype* fo_property_page_height_get_value (FoProperty *property);
FoProperty* fo_property_page_height_new_from_expression (const gchar *expression,
						    FoContext   *context,
						    FoProperty    *current_font_size,
							 FoFo *fo_node,
                                            GError    **error);
FoProperty* fo_property_page_height_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_PAGE_HEIGHT_H__ */
