/* Fo
 * fo-property-provisional-distance-between-starts.c: provisional-distance-between-starts property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-provisional-distance-between-starts.c,v 1.2 2003/03/21 14:41:39 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */

#include <string.h>
#include "libfo/fo-utils.h"
#include "fo-datatype.h"
#include "fo-property-private.h"
#include "fo-property-font-size.h"
#include <fo-property-provisional-distance-between-starts.h>

/* provisional-distance-between-starts */
/* <length> | <percentage> | inherit */
GType
fo_enum_provisional_distance_between_starts_get_type (void)
{
  static GType etype = 0;
  if (etype == 0)
    {
      static const GEnumValue values[] = {
        { FO_ENUM_PROVISIONAL_DISTANCE_BETWEEN_STARTS_INHERIT, "FO_ENUM_PROVISIONAL_DISTANCE_BETWEEN_STARTS_INHERIT", "inherit" },
        { 0, NULL, NULL }
      };
      etype = g_enum_register_static ("FoEnumProvisionalDistanceBetweenStarts", values);
    }
  return etype;
}

enum {
  PROP_0,
  PROP_VALUE
};

struct _FoPropertyProvisionalDistanceBetweenStarts
{
  FoProperty parent_instance;

  FoDatatype *value;
};

struct _FoPropertyProvisionalDistanceBetweenStartsClass
{
  FoPropertyClass parent_class;
  
};

static void fo_property_provisional_distance_between_starts_init         (FoPropertyProvisionalDistanceBetweenStarts      *property_provisional_distance_between_starts);
static void fo_property_provisional_distance_between_starts_base_class_init   (FoPropertyProvisionalDistanceBetweenStartsClass *klass);
static void fo_property_provisional_distance_between_starts_base_class_finalize   (FoPropertyProvisionalDistanceBetweenStartsClass *klass);
static void fo_property_provisional_distance_between_starts_class_init   (FoPropertyProvisionalDistanceBetweenStartsClass *klass);
static void fo_property_provisional_distance_between_starts_set_property (GObject       *object,
				    guint          prop_id,
				    const GValue  *value,
				    GParamSpec    *pspec);
static void fo_property_provisional_distance_between_starts_get_property (GObject       *object,
				    guint          prop_id,
				    GValue        *value,
				    GParamSpec    *pspec);
static void fo_property_provisional_distance_between_starts_finalize     (GObject       *object);

FoDatatype* fo_property_provisional_distance_between_starts_copy(FoDatatype *datatype);
static FoDatatype* fo_property_provisional_distance_between_starts_resolve_enum (const gchar *token,
							 FoContext *context, GError **err);
static FoDatatype* fo_property_provisional_distance_between_starts_validate (FoDatatype *datatype,
						     FoContext *context);
static gchar*      fo_property_provisional_distance_between_starts_sprintf (FoObject *object);

static gpointer parent_class;

GType
fo_property_provisional_distance_between_starts_get_type (void)
{
  static GType object_type = 0;

  if (!object_type)
    {
      static const GTypeInfo object_info =
      {
        sizeof (FoPropertyProvisionalDistanceBetweenStartsClass),
        (GBaseInitFunc) fo_property_provisional_distance_between_starts_base_class_init,
        (GBaseFinalizeFunc) fo_property_provisional_distance_between_starts_base_class_finalize,
        (GClassInitFunc) fo_property_provisional_distance_between_starts_class_init,
        NULL,           /* class_finalize */
        NULL,           /* class_data */
        sizeof (FoPropertyProvisionalDistanceBetweenStarts),
        0,              /* n_preallocs */
        (GInstanceInitFunc) fo_property_provisional_distance_between_starts_init,
      };
      
      object_type = g_type_register_static (FO_TYPE_PROPERTY,
                                            "FoPropertyProvisionalDistanceBetweenStarts",
                                            &object_info, 0);
    }
  
  return object_type;
}

static void
fo_property_provisional_distance_between_starts_init (FoPropertyProvisionalDistanceBetweenStarts *provisional_distance_between_starts)
{
  provisional_distance_between_starts->value = NULL;
}

static void
fo_property_provisional_distance_between_starts_base_class_init (FoPropertyProvisionalDistanceBetweenStartsClass *klass)
{
}

static void
fo_property_provisional_distance_between_starts_base_class_finalize (FoPropertyProvisionalDistanceBetweenStartsClass *klass)
{}

static void
fo_property_provisional_distance_between_starts_class_init (FoPropertyProvisionalDistanceBetweenStartsClass *klass)
{
  GObjectClass *object_class = G_OBJECT_CLASS (klass);
  
  parent_class = g_type_class_peek_parent (klass);
  
  object_class->finalize = fo_property_provisional_distance_between_starts_finalize;

  object_class->set_property = fo_property_provisional_distance_between_starts_set_property;
  object_class->get_property = fo_property_provisional_distance_between_starts_get_property;

  g_object_class_install_property (object_class,
                                   PROP_VALUE,
                                   g_param_spec_object ("value",
						     _("provisional-distance-between-starts value"),
						     _("provisional-distance-between-starts property value"),
							FO_TYPE_DATATYPE,
						     G_PARAM_READWRITE));

  FO_PROPERTY_CLASS(klass)->is_inherited = TRUE;
  FO_PROPERTY_CLASS(klass)->new_from_expression =
    fo_property_provisional_distance_between_starts_new_from_expression;
  FO_OBJECT_CLASS(klass)->sprintf =
    fo_property_provisional_distance_between_starts_sprintf;
  FO_PROPERTY_CLASS(klass)->set_value =
    fo_property_provisional_distance_between_starts_set_value;
  FO_PROPERTY_CLASS(klass)->get_value =
    fo_property_provisional_distance_between_starts_get_value;
}

static void
fo_property_provisional_distance_between_starts_finalize (GObject *object)
{
  FoPropertyProvisionalDistanceBetweenStarts *provisional_distance_between_starts;

  provisional_distance_between_starts = FO_PROPERTY_PROVISIONAL_DISTANCE_BETWEEN_STARTS (object);

  G_OBJECT_CLASS (parent_class)->finalize (object);
}


static void
fo_property_provisional_distance_between_starts_set_property (GObject         *object,
                         guint            prop_id,
                         const GValue    *value,
                         GParamSpec      *pspec)
{
  FoPropertyProvisionalDistanceBetweenStarts *provisional_distance_between_starts;

  provisional_distance_between_starts = FO_PROPERTY_PROVISIONAL_DISTANCE_BETWEEN_STARTS (object);

  switch (prop_id)
    {
    case PROP_VALUE:
      fo_property_provisional_distance_between_starts_set_value (FO_PROPERTY (provisional_distance_between_starts), g_value_get_object (value));
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

static void
fo_property_provisional_distance_between_starts_get_property (GObject         *object,
                         guint            prop_id,
                         GValue          *value,
                         GParamSpec      *pspec)
{
  FoPropertyProvisionalDistanceBetweenStarts *provisional_distance_between_starts;

  provisional_distance_between_starts = FO_PROPERTY_PROVISIONAL_DISTANCE_BETWEEN_STARTS (object);

  switch (prop_id)
    {
    case PROP_VALUE:
      g_value_set_instance (value,
			  fo_property_provisional_distance_between_starts_get_value (FO_PROPERTY (provisional_distance_between_starts)));
      break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
    }
}

/**
 * fo_property_provisional_distance_between_starts_new:
 * 
 * Creates a new #FoPropertyProvisionalDistanceBetweenStarts initialized to default value.
 * 
 * Return value: the new #FoPropertyProvisionalDistanceBetweenStarts
 **/
FoProperty*
fo_property_provisional_distance_between_starts_new (void)
{
  FoProperty* provisional_distance_between_starts;

  provisional_distance_between_starts =
    FO_PROPERTY (g_object_new (fo_property_provisional_distance_between_starts_get_type (), NULL));
  
  return provisional_distance_between_starts;
}

FoDatatype*
fo_property_provisional_distance_between_starts_resolve_enum (const gchar *token, FoContext *context, GError **err)
{
  g_return_val_if_fail (token != NULL, NULL);

  if (strcmp (token, "inherit") == 0)
    {
      return g_object_ref (fo_context_get_provisional_distance_between_starts (context));
    }
  else
    {
      g_warning("Unrecognized provisional-distance-between-starts enumeration token: %s", token);
      return NULL;
    }
}

FoDatatype*
fo_property_provisional_distance_between_starts_validate (FoDatatype *datatype, FoContext *context)
{
  FoDatatype *new_datatype;
  gchar *token;

  g_return_val_if_fail (datatype != NULL, NULL);
  g_return_val_if_fail (FO_IS_DATATYPE (datatype), NULL);
  g_return_val_if_fail (context != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);

  if (FO_IS_LENGTH (datatype))
    {
      return datatype;
    }
  else if (FO_IS_PERCENTAGE (datatype))
    {
      return datatype;
    }
  else if (FO_IS_ENUM (datatype))
    {
      if ((G_ENUM_CLASS_TYPE (fo_enum_get_enum_class (datatype))
           == FO_TYPE_ENUM_PROVISIONAL_DISTANCE_BETWEEN_STARTS) &&
	  (g_enum_get_value (fo_enum_get_enum_class (datatype),
			     fo_enum_get_value (datatype)) != NULL))
	{
	  return datatype;
	}
      else
	{
	  g_object_unref (datatype);

	  return NULL;
	}
    }
  else if (FO_IS_STRING (datatype))
    {
      token = fo_string_get_value (datatype);

      new_datatype = fo_property_provisional_distance_between_starts_resolve_enum (token, context, NULL);

      g_object_unref (datatype);

      return new_datatype;
    }
  else if (FO_IS_NAME (datatype))
    {
      token = fo_name_get_value (datatype);

      new_datatype = fo_property_provisional_distance_between_starts_resolve_enum (token, context, NULL);

      g_object_unref (datatype);

      return new_datatype;
    }
  else
    {
      g_warning("Invalid provisional-distance-between-starts datatype: %s (%s)",
	        fo_object_sprintf (FO_OBJECT (datatype)),
		g_type_name(G_TYPE_FROM_INSTANCE (datatype)));

      g_object_unref (datatype);

      return NULL;
    }
}

FoProperty*
fo_property_provisional_distance_between_starts_new_from_expression (const gchar *expression,
					   FoContext *context,
					   FoProperty *current_font_size,
					   FoFo *fo_node,
					   GError **error)
{
  FoProperty *provisional_distance_between_starts;
  FoDatatype *datatype;

  g_return_val_if_fail (expression != NULL, NULL);
  g_return_val_if_fail (context != NULL, NULL);
  g_return_val_if_fail (FO_IS_CONTEXT (context), NULL);
  g_return_val_if_fail
    (current_font_size == NULL || FO_IS_PROPERTY_FONT_SIZE (current_font_size),
     NULL);

  provisional_distance_between_starts = fo_property_provisional_distance_between_starts_new ();

  datatype =
    fo_property_eval_expression (expression,
				 "provisional-distance-between-starts",
				 context,
				 fo_property_provisional_distance_between_starts_resolve_enum,
				 current_font_size,
				 fo_node);

  datatype = fo_property_provisional_distance_between_starts_validate (datatype, context);

  fo_property_provisional_distance_between_starts_set_value (provisional_distance_between_starts, datatype);

  return provisional_distance_between_starts;
}

/* value */
void
fo_property_provisional_distance_between_starts_set_value (FoProperty *property,
		       FoDatatype *new_value)
{
  FoPropertyProvisionalDistanceBetweenStarts *provisional_distance_between_starts;

  g_return_if_fail (property != NULL);

  provisional_distance_between_starts = FO_PROPERTY_PROVISIONAL_DISTANCE_BETWEEN_STARTS (property);

  provisional_distance_between_starts->value = new_value;
  /*g_object_notify(G_OBJECT(provisional_distance_between_starts), "value");*/
}

FoDatatype*
fo_property_provisional_distance_between_starts_get_value (FoProperty *property)
{
  FoPropertyProvisionalDistanceBetweenStarts *provisional_distance_between_starts;

  g_return_val_if_fail (property != NULL, NULL);

  provisional_distance_between_starts = FO_PROPERTY_PROVISIONAL_DISTANCE_BETWEEN_STARTS (property);

  return provisional_distance_between_starts->value;
}

gchar*
fo_property_provisional_distance_between_starts_sprintf (FoObject *object)
{
  FoPropertyProvisionalDistanceBetweenStarts *provisional_distance_between_starts;
  FoDatatype *datatype;

  g_return_val_if_fail (object != NULL, NULL);

  provisional_distance_between_starts = FO_PROPERTY_PROVISIONAL_DISTANCE_BETWEEN_STARTS (object);
  datatype = fo_property_provisional_distance_between_starts_get_value (provisional_distance_between_starts);

  return
    g_strdup_printf ("provisional-distance-between-starts: %s",
		     fo_object_sprintf (FO_OBJECT (datatype)));
}

FoProperty*
fo_property_provisional_distance_between_starts_get_initial (void)
{
  static FoProperty *provisional_distance_between_starts = NULL;


  if (!provisional_distance_between_starts)
    {
      provisional_distance_between_starts = fo_property_provisional_distance_between_starts_new ();

      /* Set the initial value here */
      fo_property_provisional_distance_between_starts_set_value (provisional_distance_between_starts,
								 g_object_new (FO_TYPE_LENGTH,
									       "value",
									       24.0,
									       NULL));
    }

  return provisional_distance_between_starts;
}
