/* Fo
 * fo-property-scaling-method.h: 'scaling-method' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-scaling-method.h,v 1.2 2003/03/21 14:41:40 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_SCALING_METHOD_H__
#define __FO_PROPERTY_SCALING_METHOD_H__

#include <libfo/fo-utils.h>
#include "fo-context.h"

G_BEGIN_DECLS

/* scaling-method */
/* auto | integer-pixels | resample-any-method | inherit */
typedef enum {
  FO_ENUM_SCALING_METHOD_AUTO,
  FO_ENUM_SCALING_METHOD_INTEGER_PIXELS,
  FO_ENUM_SCALING_METHOD_RESAMPLE_ANY_METHOD,
  FO_ENUM_SCALING_METHOD_INHERIT
} FoEnumScalingMethod;

GType fo_enum_scaling_method_get_type (void);
#define FO_TYPE_ENUM_SCALING_METHOD fo_enum_scaling_method_get_type ()

#define FO_TYPE_PROPERTY_SCALING_METHOD              (fo_property_scaling_method_get_type ())
#define FO_PROPERTY_SCALING_METHOD(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_SCALING_METHOD, FoPropertyScalingMethod))
#define FO_PROPERTY_SCALING_METHOD_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_SCALING_METHOD, FoPropertyScalingMethodClass))
#define FO_IS_PROPERTY_SCALING_METHOD(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_SCALING_METHOD))
#define FO_IS_PROPERTY_SCALING_METHOD_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_SCALING_METHOD))
#define FO_PROPERTY_SCALING_METHOD_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_SCALING_METHOD, FoPropertyScalingMethodClass))


typedef struct _FoPropertyScalingMethod      FoPropertyScalingMethod;
typedef struct _FoPropertyScalingMethodClass FoPropertyScalingMethodClass;

GType       fo_property_scaling_method_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_scaling_method_new           (void);

void fo_property_scaling_method_set_value (FoProperty *property,
                                           FoDatatype *new_value);
FoDatatype* fo_property_scaling_method_get_value (FoProperty *property);
FoProperty* fo_property_scaling_method_new_from_expression (const gchar *expression,
                                                            FoContext   *context,
                                                            FoProperty  *current_font_size,
                                                            FoFo        *fo_node,
                                                            GError     **error);
FoProperty* fo_property_scaling_method_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_SCALING_METHOD_H__ */
