/* Fo
 * fo-property-space-after-maximum.h: space-after.maximum property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-space-after-maximum.h,v 1.2 2003/03/21 14:41:40 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */

#ifndef __FO_PROPERTY_SPACE_AFTER_MAXIMUM_H__
#define __FO_PROPERTY_SPACE_AFTER_MAXIMUM_H__

#include <libfo/fo-utils.h>
#include "fo-context.h"

G_BEGIN_DECLS

/* space-after */
/* <space> | inherit */
/* Disallow 'inherit' since this is a component of a compound property */
/* therefore *no* enumeration tokens */

#define FO_TYPE_PROPERTY_SPACE_AFTER_MAXIMUM              (fo_property_space_after_maximum_get_type ())
#define FO_PROPERTY_SPACE_AFTER_MAXIMUM(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_SPACE_AFTER_MAXIMUM, FoPropertySpaceAfterMaximum))
#define FO_PROPERTY_SPACE_AFTER_MAXIMUM_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_SPACE_AFTER_MAXIMUM, FoPropertySpaceAfterMaximumClass))
#define FO_IS_PROPERTY_SPACE_AFTER_MAXIMUM(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_SPACE_AFTER_MAXIMUM))
#define FO_IS_PROPERTY_SPACE_AFTER_MAXIMUM_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_SPACE_AFTER_MAXIMUM))
#define FO_PROPERTY_SPACE_AFTER_MAXIMUM_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_SPACE_AFTER_MAXIMUM, FoPropertySpaceAfterMaximumClass))


typedef struct _FoPropertySpaceAfterMaximum      FoPropertySpaceAfterMaximum;
typedef struct _FoPropertySpaceAfterMaximumClass FoPropertySpaceAfterMaximumClass;

GType       fo_property_space_after_maximum_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_space_after_maximum_new           (void);

void fo_property_space_after_maximum_set_value (FoProperty *property,
		      FoDatatype *new_value);
FoDatatype* fo_property_space_after_maximum_get_value (FoProperty *property);
FoProperty* fo_property_space_after_maximum_new_from_expression (const gchar *expression,
						    FoContext   *context,
						    FoProperty    *current_font_size,
							 FoFo *fo_node,
                                            GError    **error);
FoProperty* fo_property_space_after_maximum_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_SPACE_AFTER_MAXIMUM_H__ */
