/* Fo
 * fo-property-space-before.h: space-before property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-space-before.h,v 1.2 2003/03/21 14:41:43 tonygraham Exp $
 *
 * See Copyright for the status of this software.
 */
#ifndef __FO_PROPERTY_SPACE_BEFORE_H__
#define __FO_PROPERTY_SPACE_BEFORE_H__

#include <libfo/fo-utils.h>

G_BEGIN_DECLS

/* space-before */
/* <space> | inherit */
typedef enum {
  FO_ENUM_SPACE_BEFORE_INHERIT
} FoEnumSpaceBefore;

GType fo_enum_space_before_get_type (void);
#define FO_TYPE_ENUM_SPACE_BEFORE fo_enum_space_before_get_type ()

#define FO_TYPE_PROPERTY_SPACE_BEFORE              (fo_property_space_before_get_type ())
#define FO_PROPERTY_SPACE_BEFORE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_SPACE_BEFORE, FoPropertySpaceBefore))
#define FO_PROPERTY_SPACE_BEFORE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_SPACE_BEFORE, FoPropertySpaceBeforeClass))
#define FO_IS_PROPERTY_SPACE_BEFORE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_SPACE_BEFORE))
#define FO_IS_PROPERTY_SPACE_BEFORE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_SPACE_BEFORE))
#define FO_PROPERTY_SPACE_BEFORE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_SPACE_BEFORE, FoPropertySpaceBeforeClass))


typedef struct _FoPropertySpaceBefore      FoPropertySpaceBefore;
typedef struct _FoPropertySpaceBeforeClass FoPropertySpaceBeforeClass;

GType       fo_property_space_before_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_space_before_new           (void);

void fo_property_space_before_set_value (FoProperty *property,
		      FoDatatype *new_value);
FoDatatype* fo_property_space_before_get_value (FoProperty *property);
FoProperty* fo_property_space_before_new_from_expression (const gchar *expression,
						    FoContext   *context,
						    FoProperty    *current_font_size,
							 FoFo *fo_node,
                                            GError    **error);
FoProperty* fo_property_space_before_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_SPACE_BEFORE_H__ */
