/* Fo
 * fo-property-src.h: 'src' property
 *
 * Copyright (C) 2001 Sun Microsystems
 *
 * $Id: fo-property-src.h,v 1.2 2003/03/21 14:41:45 tonygraham Exp $
 *
 * See Copying for the status of this software.
 */

#ifndef __FO_PROPERTY_SRC_H__
#define __FO_PROPERTY_SRC_H__

#include <libfo/fo-utils.h>
#include "fo-context.h"

G_BEGIN_DECLS

/* src */
/* <uri-specification> | inherit */
typedef enum {
  FO_ENUM_SRC_INHERIT
} FoEnumSrc;

GType fo_enum_src_get_type (void);
#define FO_TYPE_ENUM_SRC fo_enum_src_get_type ()

#define FO_TYPE_PROPERTY_SRC              (fo_property_src_get_type ())
#define FO_PROPERTY_SRC(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), FO_TYPE_PROPERTY_SRC, FoPropertySrc))
#define FO_PROPERTY_SRC_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), FO_TYPE_PROPERTY_SRC, FoPropertySrcClass))
#define FO_IS_PROPERTY_SRC(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), FO_TYPE_PROPERTY_SRC))
#define FO_IS_PROPERTY_SRC_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), FO_TYPE_PROPERTY_SRC))
#define FO_PROPERTY_SRC_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), FO_TYPE_PROPERTY_SRC, FoPropertySrcClass))


typedef struct _FoPropertySrc      FoPropertySrc;
typedef struct _FoPropertySrcClass FoPropertySrcClass;

GType       fo_property_src_get_type      (void) G_GNUC_CONST;
FoProperty* fo_property_src_new           (void);

void fo_property_src_set_value (FoProperty *property,
                                FoDatatype *new_value);
FoDatatype* fo_property_src_get_value (FoProperty *property);
FoProperty* fo_property_src_new_from_expression (const gchar *expression,
                                                 FoContext   *context,
                                                 FoProperty  *current_font_size,
                                                 FoFo        *fo_node,
                                                 GError     **error);
FoProperty* fo_property_src_get_initial (void);

G_END_DECLS

#endif /* !__FO_PROPERTY_SRC_H__ */
